{
   "openapi": "3.0.0",
   "servers": [
      {
         "url": "https://api.nexmo.com/v1"
      }
   ],
   "info": {
      "version": "5.5.1",
      "title": "Conversation API",
      "x-metaTitle": "Vonage Conversation API (v1.0) Reference | Vonage API Documentation",
      "x-metaDescription": "Find quick answers to questions about the Vonage Conversation API (v1.0) in this reference guide. Learn more in Vonage's API documentation.",
      "description": "The Vonage Conversation API enables you to build conversation features where communication can take place across multiple mediums including IP Messaging, PSTN Voice, SMS and WebRTC Audio. The context of the conversations is maintained though each communication event taking place within a conversation, no matter the medium.",
      "contact": {
         "name": "Vonage DevRel",
         "email": "devrel@vonage.com",
         "url": "https://developer.nexmo.com/"
      }
   },
   "paths": {
      "/conversations": {
         "get": {
            "operationId": "listConversations",
            "tags": [
               "conversation"
            ],
            "summary": "List conversations",
            "description": "Get a list of all conversations that the provided JWT has access to.\nPlease note that not all data is available in the list endpoint. Once \nyou've identified the conversation you need to work with, use the \n[GET /conversations/:id](#get-conversation) endpoint to fetch all of the conversation details\n",
            "parameters": [
               {
                  "$ref": "#/components/parameters/date_start"
               },
               {
                  "$ref": "#/components/parameters/date_end"
               },
               {
                  "$ref": "#/components/parameters/page_size"
               },
               {
                  "$ref": "#/components/parameters/order"
               },
               {
                  "$ref": "#/components/parameters/cursor"
               }
            ],
            "responses": {
               "200": {
                  "description": "OK",
                  "content": {
                     "application/json": {
                        "schema": {
                           "type": "object",
                           "properties": {
                              "page_size": {
                                 "$ref": "#/components/schemas/page_size"
                              },
                              "_embedded": {
                                 "description": "A list of conversation objects. See the [get details of a specific conversation](#retrieveConversation) response fields for a description of the nested objects",
                                 "type": "object",
                                 "x-nexmo-developer-collection-description-shown": true,
                                 "properties": {
                                    "conversations": {
                                       "type": "array",
                                       "description": "List of conversations matching the provided filter",
                                       "items": {
                                          "$ref": "#/components/schemas/conversation_lite"
                                       }
                                    }
                                 },
                                 "required": [
                                    "conversations"
                                 ]
                              },
                              "_links": {
                                 "type": "object",
                                 "description": "A series of links between resources in this API in the [HAL Specification](http://stateless.co/hal_specification.html).",
                                 "properties": {
                                    "first": {
                                       "type": "object",
                                       "properties": {
                                          "href": {
                                             "type": "string",
                                             "example": "https://api.nexmo.com/v1/conversations?order=desc&page_size=10"
                                          }
                                       }
                                    },
                                    "self": {
                                       "type": "object",
                                       "properties": {
                                          "href": {
                                             "type": "string",
                                             "example": "https://api.nexmo.com/v1/conversations?order=desc&page_size=10&cursor=G%2B62WaHsQs7j85CkpyDW2TPwiyfOlRFNtZUyA2hb6eZYlCphM4erOEY%3D"
                                          }
                                       }
                                    },
                                    "next": {
                                       "type": "object",
                                       "properties": {
                                          "href": {
                                             "type": "string",
                                             "example": "https://api.nexmo.com/v1/conversations?order=desc&page_size=10&cursor=7EjDNQrAcipmOnc0HCzpQRkhBULzY44ljGUX4lXKyUIVfiZay5pv9wg%3D"
                                          }
                                       }
                                    },
                                    "prev": {
                                       "type": "object",
                                       "properties": {
                                          "href": {
                                             "type": "string",
                                             "example": "https://api.nexmo.com/v1/conversations?order=desc&page_size=10&cursor=7EjDNQrAcipmOnc0HCzpQRkhBULzY44ljGUX4lXKyUIVfiZay5pv9wg%3D"
                                          }
                                       }
                                    }
                                 },
                                 "required": [
                                    "self"
                                 ]
                              }
                           },
                           "required": [
                              "coursor",
                              "page_size",
                              "_embedded",
                              "_links"
                           ]
                        }
                     }
                  }
               },
               "400": {
                  "$ref": "#/components/responses/General400ValidationFailDateStart"
               },
               "401": {
                  "$ref": "#/components/responses/General401InvalidToken"
               },
               "500": {
                  "$ref": "#/components/responses/General500InternalError"
               }
            }
         },
         "post": {
            "operationId": "createConversation",
            "tags": [
               "conversation"
            ],
            "summary": "Create a conversation",
            "description": "Create a conversation with a unique name. The name must be unique across all conversations.\n",
            "requestBody": {
               "$ref": "#/components/requestBodies/conversation"
            },
            "responses": {
               "201": {
                  "description": "Created",
                  "content": {
                     "application/json": {
                        "schema": {
                           "$ref": "#/components/schemas/conversation"
                        }
                     }
                  }
               },
               "401": {
                  "$ref": "#/components/responses/General401InvalidToken"
               },
               "409": {
                  "$ref": "#/components/responses/Conversation409DuplicateName"
               },
               "500": {
                  "$ref": "#/components/responses/General500InternalError"
               }
            }
         }
      },
      "/conversations/{conversation_id}": {
         "parameters": [
            {
               "$ref": "#/components/parameters/conversation_id"
            }
         ],
         "get": {
            "operationId": "retrieveConversation",
            "tags": [
               "conversation"
            ],
            "summary": "Retrieve a conversation",
            "responses": {
               "200": {
                  "description": "Retrieve a conversation",
                  "content": {
                     "application/json": {
                        "schema": {
                           "$ref": "#/components/schemas/conversation"
                        }
                     }
                  }
               },
               "401": {
                  "$ref": "#/components/responses/General401InvalidToken"
               },
               "404": {
                  "$ref": "#/components/responses/Conversation404"
               },
               "500": {
                  "$ref": "#/components/responses/General500InternalError"
               }
            }
         },
         "put": {
            "operationId": "replaceConversation",
            "tags": [
               "conversation"
            ],
            "summary": "Update a conversation",
            "responses": {
               "200": {
                  "description": "Update a conversation",
                  "content": {
                     "application/json": {
                        "schema": {
                           "$ref": "#/components/schemas/conversation"
                        }
                     }
                  }
               },
               "400": {
                  "$ref": "#/components/responses/General400ValidationFailName"
               },
               "401": {
                  "$ref": "#/components/responses/General401InvalidToken"
               },
               "404": {
                  "$ref": "#/components/responses/Conversation404"
               },
               "409": {
                  "$ref": "#/components/responses/Conversation409DuplicateName"
               },
               "500": {
                  "$ref": "#/components/responses/General500InternalError"
               }
            },
            "requestBody": {
               "$ref": "#/components/requestBodies/conversation"
            }
         },
         "delete": {
            "operationId": "deleteConversation",
            "tags": [
               "conversation"
            ],
            "summary": "Delete a conversation",
            "responses": {
               "204": {
                  "$ref": "#/components/responses/General204"
               },
               "401": {
                  "$ref": "#/components/responses/General401InvalidToken"
               },
               "404": {
                  "$ref": "#/components/responses/Conversation404"
               },
               "500": {
                  "$ref": "#/components/responses/General500InternalError"
               }
            }
         }
      },
      "/conversations/{conversation_id}/members": {
         "parameters": [
            {
               "$ref": "#/components/parameters/conversation_id"
            }
         ],
         "get": {
            "operationId": "getMembers",
            "tags": [
               "member"
            ],
            "summary": "List members",
            "parameters": [
               {
                  "$ref": "#/components/parameters/page_size"
               },
               {
                  "$ref": "#/components/parameters/order"
               },
               {
                  "$ref": "#/components/parameters/cursor"
               }
            ],
            "responses": {
               "200": {
                  "description": "Members List Object",
                  "content": {
                     "application/json": {
                        "schema": {
                           "properties": {
                              "page_size": {
                                 "type": "integer",
                                 "example": 10,
                                 "description": "The number of results returned on this page"
                              },
                              "_embedded": {
                                 "type": "object",
                                 "properties": {
                                    "members": {
                                       "type": "array",
                                       "description": "List of members matching the provided filter",
                                       "items": {
                                          "$ref": "#/components/schemas/member_lite"
                                       }
                                    }
                                 }
                              },
                              "_links": {
                                 "type": "object",
                                 "properties": {
                                    "first": {
                                       "type": "object",
                                       "properties": {
                                          "href": {
                                             "type": "string",
                                             "example": "https://api.nexmo.com/v1/conversations/CON-d66d47de-5bcb-4300-94f0-0c9d4b948e9a/members?order=desc&page_size=10"
                                          }
                                       }
                                    },
                                    "self": {
                                       "type": "object",
                                       "properties": {
                                          "href": {
                                             "type": "string",
                                             "example": "https://api.nexmo.com/v1/conversations/CON-d66d47de-5bcb-4300-94f0-0c9d4b948e9a/members?order=desc&page_size=10&cursor=88b395c167da4d94e929705cbd63b82973771e7d390d274a58e301386d5762600a3ffd799bfb3fc5190c5a0d124cdd0fc72fe6e450506b18e4e2edf9fe84c7a0"
                                          }
                                       }
                                    },
                                    "next": {
                                       "type": "object",
                                       "properties": {
                                          "href": {
                                             "type": "string",
                                             "example": "https://api.nexmo.com/v1/conversations/CON-d66d47de-5bcb-4300-94f0-0c9d4b948e9a/members?order=desc&page_size=10&cursor=88b395c167da4d94e929705cbd63b829a650e69a39197bfd4c949f4243f60dc4babb696afa404d2f44e7775e32b967f2a1a0bb8fb259c0999ba5a4e501eaab55"
                                          }
                                       }
                                    },
                                    "prev": {
                                       "type": "object",
                                       "properties": {
                                          "href": {
                                             "type": "string",
                                             "example": "https://api.nexmo.com/v1/conversations/CON-d66d47de-5bcb-4300-94f0-0c9d4b948e9a/members?order=desc&page_size=10&cursor=069626a3de11d2ec900dff5042197bd75f1ce41dafc3f2b2481eb9151086e59aae9dba3e3a8858dc355232d499c310fbfbec43923ff657c0de8d49ffed9f7edb"
                                          }
                                       }
                                    }
                                 }
                              }
                           }
                        }
                     }
                  }
               },
               "401": {
                  "$ref": "#/components/responses/General401InvalidToken"
               },
               "404": {
                  "$ref": "#/components/responses/Conversation404"
               },
               "500": {
                  "$ref": "#/components/responses/General500InternalError"
               }
            }
         },
         "post": {
            "operationId": "createMember",
            "tags": [
               "member"
            ],
            "summary": "Create a member",
            "requestBody": {
               "content": {
                  "application/json": {
                     "schema": {
                        "type": "object",
                        "description": "Create a Member in invited or joined state",
                        "properties": {
                           "state": {
                              "$ref": "#/components/schemas/member_state_request"
                           },
                           "user": {
                              "type": "object",
                              "description": "Either the user id or name is required.",
                              "properties": {
                                 "id": {
                                    "$ref": "#/components/schemas/user_id"
                                 },
                                 "name": {
                                    "$ref": "#/components/schemas/user_name"
                                 }
                              }
                           },
                           "channel": {
                              "$ref": "#/components/schemas/channel"
                           },
                           "media": {
                              "$ref": "#/components/schemas/media"
                           },
                           "knocking_id": {
                              "$ref": "#/components/schemas/knocker_id"
                           },
                           "member_id_inviting": {
                              "$ref": "#/components/schemas/member_id_inviting"
                           },
                           "from": {
                              "$ref": "#/components/schemas/member_from"
                           }
                        },
                        "required": [
                           "user",
                           "state",
                           "channel"
                        ]
                     }
                  }
               }
            },
            "responses": {
               "201": {
                  "description": "Create a member",
                  "content": {
                     "application/json": {
                        "schema": {
                           "$ref": "#/components/schemas/member"
                        }
                     }
                  }
               },
               "400": {
                  "description": "OK",
                  "content": {
                     "application/json": {
                        "schema": {
                           "oneOf": [
                              {
                                 "$ref": "#/components/schemas/member_error_validation_state_invited"
                              },
                              {
                                 "$ref": "#/components/schemas/member_error_already_joined"
                              }
                           ]
                        }
                     }
                  }
               },
               "401": {
                  "$ref": "#/components/responses/General401InvalidToken"
               },
               "404": {
                  "$ref": "#/components/responses/User404"
               },
               "500": {
                  "$ref": "#/components/responses/General500InternalError"
               }
            }
         }
      },
      "/conversations/{conversation_id}/members/me": {
         "get": {
            "operationId": "getMe",
            "tags": [
               "member"
            ],
            "summary": "Retrieve your member",
            "description": "This retrieves the member associated with the sub claim on the JWT",
            "parameters": [
               {
                  "$ref": "#/components/parameters/conversation_id"
               }
            ],
            "responses": {
               "200": {
                  "description": "Retrieve member payload",
                  "content": {
                     "application/json": {
                        "schema": {
                           "$ref": "#/components/schemas/member"
                        }
                     }
                  }
               },
               "401": {
                  "$ref": "#/components/responses/General401InvalidToken"
               },
               "404": {
                  "description": "Not found.",
                  "content": {
                     "application/json": {
                        "schema": {
                           "oneOf": [
                              {
                                 "$ref": "#/components/schemas/conversation_error_not_found"
                              },
                              {
                                 "$ref": "#/components/schemas/member_error_not_found"
                              }
                           ]
                        }
                     }
                  }
               },
               "500": {
                  "$ref": "#/components/responses/General500InternalError"
               }
            }
         }
      },
      "/conversations/{conversation_id}/members/{member_id}": {
         "parameters": [
            {
               "$ref": "#/components/parameters/conversation_id"
            },
            {
               "$ref": "#/components/parameters/member_id"
            }
         ],
         "get": {
            "operationId": "getMember",
            "tags": [
               "member"
            ],
            "summary": "Retrieve a member",
            "responses": {
               "200": {
                  "description": "Retrieve member payload",
                  "content": {
                     "application/json": {
                        "schema": {
                           "allOf": [
                              {
                                 "$ref": "#/components/schemas/member"
                              },
                              {
                                 "type": "object",
                                 "properties": {
                                    "state": {
                                       "type": "string",
                                       "example": "JOINED"
                                    }
                                 }
                              }
                           ]
                        }
                     }
                  }
               },
               "401": {
                  "$ref": "#/components/responses/General401InvalidToken"
               },
               "404": {
                  "description": "Not found.",
                  "content": {
                     "application/json": {
                        "schema": {
                           "oneOf": [
                              {
                                 "$ref": "#/components/schemas/conversation_error_not_found"
                              },
                              {
                                 "$ref": "#/components/schemas/member_error_not_found"
                              }
                           ]
                        }
                     }
                  }
               },
               "500": {
                  "$ref": "#/components/responses/General500InternalError"
               }
            }
         },
         "patch": {
            "operationId": "updateMember",
            "tags": [
               "member"
            ],
            "summary": "Update a member",
            "description": "Setting the `state` to `left` will result in the member leaving the conversation.\n",
            "requestBody": {
               "content": {
                  "application/json": {
                     "schema": {
                        "oneOf": [
                           {
                              "title": "Set state to Joined",
                              "properties": {
                                 "state": {
                                    "type": "string",
                                    "enum": [
                                       "joined"
                                    ]
                                 },
                                 "from": {
                                    "type": "string"
                                 }
                              }
                           },
                           {
                              "title": "Set state to Left",
                              "properties": {
                                 "state": {
                                    "type": "string",
                                    "enum": [
                                       "left"
                                    ]
                                 },
                                 "from": {
                                    "type": "string"
                                 },
                                 "reason": {
                                    "type": "object",
                                    "properties": {
                                       "code": {
                                          "type": "string"
                                       },
                                       "text": {
                                          "type": "string"
                                       }
                                    }
                                 }
                              }
                           }
                        ]
                     }
                  }
               }
            },
            "responses": {
               "200": {
                  "description": "Member updated",
                  "content": {
                     "application/json": {
                        "schema": {
                           "allOf": [
                              {
                                 "$ref": "#/components/schemas/member"
                              }
                           ]
                        }
                     }
                  }
               },
               "400": {
                  "description": "OK",
                  "content": {
                     "application/json": {
                        "schema": {
                           "oneOf": [
                              {
                                 "$ref": "#/components/schemas/member_error_validation_state"
                              },
                              {
                                 "$ref": "#/components/schemas/member_error_invalid_state"
                              },
                              {
                                 "$ref": "#/components/schemas/member_error_already_joined"
                              }
                           ]
                        }
                     }
                  }
               },
               "401": {
                  "$ref": "#/components/responses/General401InvalidToken"
               },
               "404": {
                  "description": "Not found.",
                  "content": {
                     "application/json": {
                        "schema": {
                           "oneOf": [
                              {
                                 "$ref": "#/components/schemas/conversation_error_not_found"
                              },
                              {
                                 "$ref": "#/components/schemas/member_error_not_found"
                              }
                           ]
                        }
                     }
                  }
               },
               "500": {
                  "$ref": "#/components/responses/General500InternalError"
               }
            }
         }
      },
      "/conversations/{conversation_id}/events": {
         "post": {
            "operationId": "createEvent",
            "description": "Events are used to record actions that take place within a conversation. Some events are created automatically when carrying out actions such as adding a user to a conversation, but you can also create custom events to record other actions that take place within a conversation.\nFor more details on event types and how they should be used please see the\n[event concept documentation](/conversation/concepts/event).\n",
            "tags": [
               "event"
            ],
            "summary": "Create an event",
            "parameters": [
               {
                  "$ref": "#/components/parameters/conversation_id"
               }
            ],
            "requestBody": {
               "$ref": "#/components/requestBodies/event"
            },
            "responses": {
               "201": {
                  "$ref": "#/components/responses/event"
               },
               "401": {
                  "$ref": "#/components/responses/General401InvalidToken"
               },
               "404": {
                  "$ref": "#/components/responses/Conversation404"
               },
               "500": {
                  "$ref": "#/components/responses/General500InternalError"
               }
            }
         },
         "get": {
            "operationId": "getEvents",
            "tags": [
               "event"
            ],
            "summary": "Get a list of events",
            "parameters": [
               {
                  "$ref": "#/components/parameters/event_start_id"
               },
               {
                  "$ref": "#/components/parameters/event_end_id"
               },
               {
                  "$ref": "#/components/parameters/event_type"
               },
               {
                  "$ref": "#/components/parameters/page_size"
               },
               {
                  "$ref": "#/components/parameters/order"
               },
               {
                  "$ref": "#/components/parameters/cursor"
               },
               {
                  "$ref": "#/components/parameters/exclude_deleted_events"
               },
               {
                  "$ref": "#/components/parameters/conversation_id"
               }
            ],
            "responses": {
               "200": {
                  "$ref": "#/components/responses/event_list"
               },
               "401": {
                  "$ref": "#/components/responses/General401InvalidToken"
               },
               "404": {
                  "$ref": "#/components/responses/Conversation404"
               },
               "500": {
                  "$ref": "#/components/responses/General500InternalError"
               }
            }
         }
      },
      "/conversations/{conversation_id}/events/{event_id}": {
         "get": {
            "operationId": "getEvent",
            "tags": [
               "event"
            ],
            "summary": "Get an event",
            "parameters": [
               {
                  "$ref": "#/components/parameters/conversation_id"
               },
               {
                  "$ref": "#/components/parameters/event_id"
               }
            ],
            "responses": {
               "200": {
                  "$ref": "#/components/responses/event_single"
               },
               "401": {
                  "$ref": "#/components/responses/General401InvalidToken"
               },
               "404": {
                  "description": "Not found.",
                  "content": {
                     "application/json": {
                        "schema": {
                           "oneOf": [
                              {
                                 "$ref": "#/components/schemas/conversation_error_not_found"
                              },
                              {
                                 "$ref": "#/components/schemas/event_error_not_found"
                              }
                           ]
                        }
                     }
                  }
               },
               "500": {
                  "$ref": "#/components/responses/General500InternalError"
               }
            }
         },
         "delete": {
            "operationId": "deleteEvent",
            "tags": [
               "event"
            ],
            "summary": "Delete an event",
            "description": "Only message and custom events can be deleted, and then only events your user created or if you use an admin token",
            "parameters": [
               {
                  "in": "path",
                  "name": "conversation_id",
                  "required": true,
                  "schema": {
                     "$ref": "#/components/schemas/conversation_id"
                  },
                  "description": "The conversation ID"
               },
               {
                  "in": "path",
                  "name": "event_id",
                  "required": true,
                  "schema": {
                     "$ref": "#/components/schemas/event_id"
                  },
                  "description": "The event ID"
               }
            ],
            "responses": {
               "204": {
                  "$ref": "#/components/responses/General204"
               },
               "401": {
                  "$ref": "#/components/responses/General401InvalidToken"
               },
               "404": {
                  "description": "Not found.",
                  "content": {
                     "application/json": {
                        "schema": {
                           "oneOf": [
                              {
                                 "$ref": "#/components/schemas/conversation_error_not_found"
                              },
                              {
                                 "$ref": "#/components/schemas/event_error_not_found"
                              }
                           ]
                        }
                     }
                  }
               },
               "500": {
                  "$ref": "#/components/responses/General500InternalError"
               }
            }
         }
      },
      "/users/{user_id}/conversations": {
         "parameters": [
            {
               "$ref": "#/components/parameters/user_id"
            }
         ],
         "get": {
            "operationId": "getuserConversations",
            "tags": [
               "user"
            ],
            "summary": "List user conversations",
            "description": "Please note that not all data is available in the list endpoint. Once \nyou've identified the conversation you need to work with, use the \n[GET /conversations/:id](#get-conversation) endpoint to fetch all of the conversation details\n",
            "parameters": [
               {
                  "$ref": "#/components/parameters/date_start"
               },
               {
                  "$ref": "#/components/parameters/page_size"
               },
               {
                  "$ref": "#/components/parameters/order"
               },
               {
                  "$ref": "#/components/parameters/cursor"
               },
               {
                  "$ref": "#/components/parameters/member_state"
               },
               {
                  "$ref": "#/components/parameters/order_by"
               },
               {
                  "$ref": "#/components/parameters/include_custom_data"
               }
            ],
            "responses": {
               "200": {
                  "description": "OK",
                  "content": {
                     "application/json": {
                        "schema": {
                           "type": "object",
                           "properties": {
                              "page_size": {
                                 "$ref": "#/components/schemas/page_size"
                              },
                              "_embedded": {
                                 "description": "A list of conversation objects. See the [get details of a specific conversation](#retrieveConversation) response fields for a description of the nested objects",
                                 "type": "object",
                                 "x-nexmo-developer-collection-description-shown": true,
                                 "properties": {
                                    "conversations": {
                                       "type": "array",
                                       "description": "List of conversations matching the provided filter",
                                       "items": {
                                          "$ref": "#/components/schemas/conversation_user"
                                       }
                                    }
                                 },
                                 "required": [
                                    "conversations"
                                 ]
                              },
                              "_links": {
                                 "type": "object",
                                 "description": "A series of links between resources in this API in the http://stateless.co/hal_specification.html.",
                                 "properties": {
                                    "first": {
                                       "type": "object",
                                       "properties": {
                                          "href": {
                                             "type": "string",
                                             "example": "https://api.nexmo.com/v1/users/USR-82e028d9-5201-4f1e-8188-604b2d3471ec/conversations?order=desc&page_size=10"
                                          }
                                       }
                                    },
                                    "self": {
                                       "type": "object",
                                       "properties": {
                                          "href": {
                                             "type": "string",
                                             "example": "https://api.nexmo.com/v1/users/USR-82e028d9-5201-4f1e-8188-604b2d3471ec/conversations?order=desc&page_size=10&cursor=7EjDNQrAcipmOnc0HCzpQRkhBULzY44ljGUX4lXKyUIVfiZay5pv9wg%3D"
                                          }
                                       }
                                    },
                                    "next": {
                                       "type": "object",
                                       "properties": {
                                          "href": {
                                             "type": "string",
                                             "example": "https://api.nexmo.com/v1/users/USR-82e028d9-5201-4f1e-8188-604b2d3471ec/conversations?order=desc&page_size=10&cursor=7EjDNQrAcipmOnc0HCzpQRkhBULzY44ljGUX4lXKyUIVfiZay5pv9wg%3D"
                                          }
                                       }
                                    },
                                    "prev": {
                                       "type": "object",
                                       "properties": {
                                          "href": {
                                             "type": "string",
                                             "example": "https://api.nexmo.com/v1/users/USR-82e028d9-5201-4f1e-8188-604b2d3471ec/conversations?order=desc&page_size=10&cursor=7EjDNQrAcipmOnc0HCzpQRkhBULzY44ljGUX4lXKyUIVfiZay5pv9wg%3D"
                                          }
                                       }
                                    }
                                 },
                                 "required": [
                                    "self"
                                 ]
                              }
                           },
                           "required": [
                              "coursor",
                              "page_size",
                              "_embedded",
                              "_links"
                           ]
                        }
                     }
                  }
               },
               "401": {
                  "$ref": "#/components/responses/General401InvalidToken"
               },
               "404": {
                  "$ref": "#/components/responses/User404"
               },
               "500": {
                  "$ref": "#/components/responses/General500InternalError"
               }
            }
         }
      },
      "/conversations/{conversation_id}/talk": {
         "parameters": [
            {
               "$ref": "#/components/parameters/conversation_id"
            }
         ],
         "put": {
            "operationId": "talk",
            "tags": [
               "talk"
            ],
            "summary": "Play the given text into the conversation via TTS",
            "responses": {
               "200": {
                  "$ref": "#/components/responses/conversationTalk"
               },
               "400": {
                  "$ref": "#/components/responses/General400ValidationFailName"
               },
               "401": {
                  "$ref": "#/components/responses/General401InvalidToken"
               },
               "404": {
                  "$ref": "#/components/responses/Conversation404"
               },
               "500": {
                  "$ref": "#/components/responses/General500InternalError"
               }
            },
            "requestBody": {
               "$ref": "#/components/requestBodies/conversationTalk"
            }
         },
         "delete": {
            "tags": [
               "talk"
            ],
            "summary": "Stop text to speech in a call",
            "description": "Stop text to speech in a call",
            "operationId": "stopTalk",
            "responses": {
               "200": {
                  "description": "Ok",
                  "content": {
                     "application/json": {
                        "schema": {
                           "$ref": "#/components/schemas/StopTalkResponse"
                        }
                     }
                  }
               },
               "400": {
                  "$ref": "#/components/responses/General400ValidationFailName"
               },
               "401": {
                  "$ref": "#/components/responses/General401InvalidToken"
               },
               "404": {
                  "$ref": "#/components/responses/Conversation404"
               },
               "500": {
                  "$ref": "#/components/responses/General500InternalError"
               }
            }
         }
      },
      "/conversations/{conversation_id}/stream": {
         "parameters": [
            {
               "$ref": "#/components/parameters/conversation_id"
            }
         ],
         "put": {
            "tags": [
               "stream"
            ],
            "summary": "Play an audio file into a conversation",
            "description": "Play an audio file into a conversation",
            "operationId": "startStream",
            "requestBody": {
               "description": "action to perform",
               "required": true,
               "content": {
                  "application/json": {
                     "schema": {
                        "$ref": "#/components/schemas/StartStreamRequest"
                     }
                  }
               }
            },
            "responses": {
               "200": {
                  "description": "Ok",
                  "content": {
                     "application/json": {
                        "schema": {
                           "$ref": "#/components/schemas/StartStreamResponse"
                        }
                     }
                  }
               },
               "400": {
                  "$ref": "#/components/responses/General400ValidationFailName"
               },
               "401": {
                  "$ref": "#/components/responses/General401InvalidToken"
               },
               "404": {
                  "$ref": "#/components/responses/Conversation404"
               },
               "500": {
                  "$ref": "#/components/responses/General500InternalError"
               }
            }
         },
         "delete": {
            "tags": [
               "stream"
            ],
            "summary": "Stop playing an audio file into a conversation",
            "description": "Stop playing an audio file into a conversation",
            "operationId": "stopStream",
            "responses": {
               "200": {
                  "description": "Ok",
                  "content": {
                     "application/json": {
                        "schema": {
                           "$ref": "#/components/schemas/StopStreamResponse"
                        }
                     }
                  }
               },
               "400": {
                  "$ref": "#/components/responses/General400ValidationFailName"
               },
               "401": {
                  "$ref": "#/components/responses/General401InvalidToken"
               },
               "404": {
                  "$ref": "#/components/responses/Conversation404"
               },
               "500": {
                  "$ref": "#/components/responses/General500InternalError"
               }
            }
         }
      },
      "/conversations/{conversation_id}/record": {
         "parameters": [
            {
               "$ref": "#/components/parameters/conversation_id"
            }
         ],
         "put": {
            "tags": [
               "record"
            ],
            "summary": "Start or stop a conversation recording",
            "description": "Start or stop a recording for a conversation.",
            "operationId": "recordConversation",
            "requestBody": {
               "$ref": "#/components/requestBodies/RecordConversation"
            },
            "responses": {
               "200": {
                  "description": "Recording action successfully initiated."
               },
               "400": {
                  "$ref": "#/components/responses/General400ValidationFailName"
               },
               "401": {
                  "$ref": "#/components/responses/General401InvalidToken"
               },
               "404": {
                  "$ref": "#/components/responses/Conversation404"
               },
               "500": {
                  "$ref": "#/components/responses/General500InternalError"
               }
            }
         }
      }
   },
   "components": {
      "schemas": {
         "StopStreamResponse": {
            "type": "object",
            "properties": {
               "message": {
                  "description": "Description of the action taken",
                  "type": "string",
                  "example": "Stream stopped"
               },
               "uuid": {
                  "type": "string",
                  "example": "ef5400a8-6131-4aa7-9913-11d58ddaeab9"
               }
            }
         },
         "StartStreamResponse": {
            "type": "object",
            "properties": {
               "message": {
                  "description": "Description of the action taken",
                  "type": "string",
                  "example": "Stream started"
               },
               "uuid": {
                  "type": "string",
                  "example": "ef5400a8-6131-4aa7-9913-11d58ddaeab9"
               }
            }
         },
         "StartStreamRequest": {
            "type": "object",
            "required": [
               "stream_url"
            ],
            "properties": {
               "stream_url": {
                  "x-nexmo-developer-collection-description-shown": true,
                  "example": [
                     "https://example.com/waiting.mp3"
                  ],
                  "type": "array",
                  "items": {
                     "type": "string"
                  }
               },
               "loop": {
                  "type": "integer",
                  "description": "the number of times to play the file, 0 for infinite",
                  "default": 1
               },
               "level": {
                  "type": "string",
                  "description": "Set the audio level of the stream in the range `-1 >= level <= 1` with a precision of 0.1. The default value is 0.",
                  "example": "0.4",
                  "default": "0"
               }
            }
         },
         "StopTalkResponse": {
            "type": "object",
            "properties": {
               "message": {
                  "description": "Description of the action taken",
                  "type": "string",
                  "example": "Talk stopped"
               },
               "uuid": {
                  "type": "string",
                  "example": "ef5400a8-6131-4aa7-9913-11d58ddaeab9"
               }
            }
         },
         "language": {
            "description": "The language to use",
            "type": "string",
            "default": "en-US",
            "enum": [
               "ar",
               "ca-ES",
               "cmn-CN",
               "cmn-TW",
               "cs-CZ",
               "cy-GB",
               "da-DK",
               "de-DE",
               "el-GR",
               "en-AU",
               "en-GB",
               "en-GB-WLS",
               "en-IN",
               "en-US",
               "en-ZA",
               "es-ES",
               "es-MX",
               "es-US",
               "eu-ES",
               "fi-FI",
               "fil-PH",
               "fr-CA",
               "fr-FR",
               "he-IL",
               "hi-IN",
               "hu-HU",
               "id-ID",
               "is-IS",
               "it-IT",
               "ja-JP",
               "ko-KR",
               "nb-NO",
               "nl-NL",
               "no-NO",
               "pl-PL",
               "pt-BR",
               "pt-PT",
               "ro-RO",
               "ru-RU",
               "sk-SK",
               "sv-SE",
               "th-TH",
               "tr-TR",
               "uk-UA",
               "vi-VN",
               "yue-CN"
            ]
         },
         "style": {
            "description": "The vocal style (vocal range, tessitura, and timbre) to use",
            "type": "integer",
            "default": 0
         },
         "user_lite": {
            "type": "object",
            "properties": {
               "id": {
                  "$ref": "#/components/schemas/user_id"
               },
               "name": {
                  "$ref": "#/components/schemas/user_name"
               },
               "display_name": {
                  "$ref": "#/components/schemas/user_display_name"
               },
               "_links": {
                  "$ref": "#/components/schemas/user_links"
               }
            }
         },
         "user": {
            "type": "object",
            "properties": {
               "id": {
                  "$ref": "#/components/schemas/user_id"
               },
               "name": {
                  "$ref": "#/components/schemas/user_name"
               },
               "display_name": {
                  "$ref": "#/components/schemas/user_display_name"
               },
               "image_url": {
                  "$ref": "#/components/schemas/user_image_url"
               },
               "properties": {
                  "$ref": "#/components/schemas/user_properties"
               },
               "channels": {
                  "$ref": "#/components/schemas/user_channels"
               },
               "_links": {
                  "$ref": "#/components/schemas/user_links"
               },
               "timestamp": {
                  "$ref": "#/components/schemas/user_timestamp"
               }
            }
         },
         "user_id": {
            "type": "string",
            "example": "USR-82e028d9-5201-4f1e-8188-604b2d3471ec",
            "description": "User ID"
         },
         "user_name": {
            "type": "string",
            "example": "my_user_name",
            "description": "Unique name for a user",
            "nullable": true
         },
         "user_display_name": {
            "type": "string",
            "example": "My User Name",
            "description": "A string to be displayed as user name. It does not need to be unique",
            "nullable": true
         },
         "user_image_url": {
            "type": "string",
            "example": "https://example.com/image.png",
            "description": "An image URL that you associate with the user"
         },
         "user_properties": {
            "type": "object",
            "description": "User properties",
            "properties": {
               "custom_data": {
                  "type": "object"
               }
            }
         },
         "user_channels": {
            "type": "object",
            "properties": {
               "pstn": {
                  "type": "array",
                  "items": {
                     "type": "object",
                     "additionalProperties": {
                        "type": "string"
                     }
                  }
               },
               "sip": {
                  "type": "array",
                  "items": {
                     "type": "object",
                     "additionalProperties": {
                        "type": "string"
                     }
                  }
               },
               "vbc": {
                  "type": "array",
                  "items": {
                     "type": "object",
                     "additionalProperties": {
                        "type": "string"
                     }
                  }
               },
               "websocket": {
                  "type": "array",
                  "items": {
                     "type": "object",
                     "additionalProperties": {
                        "type": "string"
                     }
                  }
               },
               "sms": {
                  "type": "array",
                  "items": {
                     "type": "object",
                     "properties": {
                        "number": {
                           "type": "string",
                           "example": "447700900000"
                        }
                     },
                     "required": [
                        "number"
                     ],
                     "additionalProperties": {
                        "type": "string"
                     }
                  }
               },
               "mms": {
                  "type": "array",
                  "items": {
                     "type": "object",
                     "properties": {
                        "number": {
                           "type": "string",
                           "example": "447700900000"
                        }
                     },
                     "required": [
                        "number"
                     ],
                     "additionalProperties": {
                        "type": "string"
                     }
                  }
               },
               "whatsapp": {
                  "type": "array",
                  "items": {
                     "type": "object",
                     "properties": {
                        "number": {
                           "type": "string",
                           "example": "447700900000"
                        }
                     },
                     "required": [
                        "number"
                     ],
                     "additionalProperties": {
                        "type": "string"
                     }
                  }
               },
               "viber": {
                  "type": "array",
                  "items": {
                     "type": "object",
                     "properties": {
                        "number": {
                           "type": "string",
                           "example": "447700900000"
                        }
                     },
                     "required": [
                        "number"
                     ],
                     "additionalProperties": {
                        "type": "string"
                     }
                  }
               },
               "messenger": {
                  "type": "array",
                  "items": {
                     "type": "object",
                     "properties": {
                        "id": {
                           "type": "string",
                           "example": "0"
                        }
                     },
                     "required": [
                        "id"
                     ],
                     "additionalProperties": {
                        "type": "string"
                     }
                  }
               }
            }
         },
         "user_links": {
            "type": "object",
            "properties": {
               "self": {
                  "type": "object",
                  "properties": {
                     "href": {
                        "type": "string",
                        "example": "https://api.nexmo.com/v1/users/USR-82e028d9-5201-4f1e-8188-604b2d3471ec"
                     }
                  }
               }
            }
         },
         "user_timestamp": {
            "type": "object",
            "properties": {
               "created": {
                  "$ref": "#/components/schemas/timestamp_created"
               },
               "updated": {
                  "$ref": "#/components/schemas/timestamp_updated"
               },
               "destroyed": {
                  "$ref": "#/components/schemas/timestamp_destroyed"
               }
            }
         },
         "conversation_lite": {
            "type": "object",
            "properties": {
               "id": {
                  "$ref": "#/components/schemas/conversation_id"
               },
               "name": {
                  "$ref": "#/components/schemas/conversation_name"
               },
               "display_name": {
                  "$ref": "#/components/schemas/conversation_display_name"
               },
               "image_url": {
                  "$ref": "#/components/schemas/conversation_image_url"
               },
               "timestamp": {
                  "$ref": "#/components/schemas/conversation_timestamp"
               },
               "_links": {
                  "$ref": "#/components/schemas/conversation_links"
               }
            }
         },
         "conversation_user": {
            "type": "object",
            "properties": {
               "id": {
                  "$ref": "#/components/schemas/conversation_id"
               },
               "name": {
                  "$ref": "#/components/schemas/conversation_name"
               },
               "display_name": {
                  "$ref": "#/components/schemas/conversation_display_name"
               },
               "image_url": {
                  "$ref": "#/components/schemas/conversation_image_url"
               },
               "sequence_number": {
                  "$ref": "#/components/schemas/conversation_sequence_number"
               },
               "properties": {
                  "$ref": "#/components/schemas/conversation_properties"
               },
               "timestamp": {
                  "$ref": "#/components/schemas/conversation_timestamp"
               },
               "_links": {
                  "$ref": "#/components/schemas/conversation_links"
               },
               "_embedded": {
                  "$ref": "#/components/schemas/conversation_members"
               }
            }
         },
         "conversation": {
            "type": "object",
            "description": "Conversation Object",
            "properties": {
               "id": {
                  "$ref": "#/components/schemas/conversation_id"
               },
               "name": {
                  "$ref": "#/components/schemas/conversation_name"
               },
               "display_name": {
                  "$ref": "#/components/schemas/conversation_display_name"
               },
               "image_url": {
                  "$ref": "#/components/schemas/conversation_image_url"
               },
               "state": {
                  "$ref": "#/components/schemas/conversation_state"
               },
               "sequence_number": {
                  "$ref": "#/components/schemas/conversation_sequence_number"
               },
               "timestamp": {
                  "$ref": "#/components/schemas/conversation_timestamp"
               },
               "properties": {
                  "$ref": "#/components/schemas/conversation_properties"
               },
               "_links": {
                  "$ref": "#/components/schemas/conversation_links"
               }
            }
         },
         "conversation_id": {
            "type": "string",
            "example": "CON-d66d47de-5bcb-4300-94f0-0c9d4b948e9a",
            "description": "The unique identifier for this conversation"
         },
         "conversation_name": {
            "type": "string",
            "example": "customer_chat",
            "description": "Your internal conversation name. Must be unique. If not supplied a randomly generated name will be used.",
            "maxLength": 100
         },
         "conversation_display_name": {
            "type": "string",
            "example": "Customer Chat",
            "description": "The public facing name of the conversation",
            "nullable": true,
            "maxLength": 50
         },
         "conversation_image_url": {
            "type": "string",
            "example": "https://example.com/image.png",
            "description": "An image URL that you associate with the conversation",
            "format": "uri",
            "maxLength": 2048,
            "nullable": true
         },
         "conversation_timestamp": {
            "type": "object",
            "properties": {
               "created": {
                  "type": "string",
                  "example": "2019-09-03T18:40:24.324Z",
                  "description": "The time that the conversation was created"
               },
               "updated": {
                  "type": "string",
                  "example": "2019-09-03T18:50:24.324Z",
                  "description": "The time that the conversation was updated",
                  "nullable": true
               },
               "destroyed": {
                  "type": "string",
                  "example": "2019-09-05T18:40:24.324Z",
                  "description": "The time that the conversation was destroyed",
                  "nullable": true
               }
            }
         },
         "conversation_state": {
            "type": "string",
            "enum": [
               "ACTIVE",
               "INACTIVE",
               "DELETED"
            ],
            "example": "ACTIVE",
            "description": "The state the conversation is in."
         },
         "conversation_sequence_number": {
            "type": "integer",
            "example": 0,
            "description": "The last Event ID in this conversation. This ID can be used to [retrieve a specific event](#getEvent)."
         },
         "conversation_properties": {
            "type": "object",
            "description": "Conversation properties",
            "properties": {
               "ttl": {
                  "type": "integer",
                  "example": 60,
                  "description": "Time to leave. After how many seconds an empty conversation is deleted.",
                  "minimum": 0,
                  "maximum": 2147483648
               },
               "custom_data": {
                  "type": "object",
                  "description": "Custom Key value pairs to be included with conversation data",
                  "additionalProperties": {
                     "type": "string"
                  }
               }
            }
         },
         "conversation_links": {
            "type": "object",
            "properties": {
               "self": {
                  "type": "object",
                  "properties": {
                     "href": {
                        "type": "string",
                        "example": "https://api.nexmo.com/v1/conversations/CON-7f977ca5-6e86-46a8-bdc9-67b9d8c8dfa9"
                     }
                  }
               }
            }
         },
         "conversation_numbers": {
            "type": "array",
            "description": "An array containing number on different channels.",
            "oneOf": [
               {
                  "type": "object",
                  "description": "Phone Channel",
                  "properties": {
                     "type": {
                        "type": "string",
                        "enum": [
                           "phone"
                        ],
                        "example": "phone"
                     },
                     "number": {
                        "type": "string",
                        "example": "447700900000"
                     }
                  }
               }
            ]
         },
         "conversation_callback": {
            "type": "object",
            "properties": {
               "url": {
                  "type": "string",
                  "description": "The URL to send conversation events to.",
                  "example": "https://example.com/eventcallback",
                  "format": "uri",
                  "maxLength": 2048
               },
               "event_mask": {
                  "description": "A comma separated string detailing the events to send to the callback URL. If not supplied all events will be sent.",
                  "example": "member:invited, member:joined",
                  "type": "string",
                  "maxLength": 200
               },
               "params": {
                  "type": "object",
                  "properties": {
                     "applicationId": {
                        "description": "The application ID that the event is associated with.",
                        "type": "string",
                        "maxLength": 200
                     },
                     "ncco_url": {
                        "description": "The URL to send the NCCO to.",
                        "example": "https://example.com/ncco",
                        "type": "string",
                        "format": "uri",
                        "maxLength": 2048
                     }
                  }
               },
               "method": {
                  "description": "The HTTP method to use when sending events to the callback URL.",
                  "type": "string",
                  "default": "POST",
                  "enum": [
                     "POST",
                     "GET"
                  ]
               }
            }
         },
         "conversation_numbers_phone": {
            "description": "Phone Channel",
            "type": "object",
            "properties": {
               "type": {
                  "type": "string",
                  "enum": [
                     "phone"
                  ],
                  "example": "phone"
               },
               "number": {
                  "type": "string",
                  "example": "447700900000"
               }
            },
            "required": [
               "type",
               "number"
            ]
         },
         "conversation_numbers_sip": {
            "description": "SIP Channel",
            "type": "object",
            "properties": {
               "type": {
                  "type": "string",
                  "enum": [
                     "sip"
                  ],
                  "example": "sip"
               },
               "uri": {
                  "type": "string",
                  "maxLength": 200,
                  "pattern": "^(sip|sips):\\+?([\\w|:.\\-@;,=%&]+)",
                  "example": "sip:+Htg:;xa"
               },
               "usenname": {
                  "type": "string"
               },
               "password": {
                  "type": "string"
               }
            },
            "required": [
               "type",
               "uri"
            ]
         },
         "conversation_numbers_app": {
            "description": "App Channel",
            "type": "object",
            "properties": {
               "type": {
                  "type": "string",
                  "enum": [
                     "app"
                  ],
                  "example": "app"
               },
               "user": {
                  "type": "string"
               }
            },
            "required": [
               "type"
            ]
         },
         "conversation_numbers_websocket": {
            "description": "Websocket Channel",
            "type": "object",
            "properties": {
               "type": {
                  "type": "string",
                  "enum": [
                     "websocket"
                  ],
                  "example": "websocket"
               },
               "uri": {
                  "type": "string",
                  "maxLength": 200,
                  "example": "ws://example.com:8080"
               },
               "content_type": {
                  "type": "string"
               }
            },
            "required": [
               "type",
               "uri"
            ]
         },
         "conversation_numbers_vbc": {
            "description": "VBC Channel",
            "type": "object",
            "properties": {
               "type": {
                  "type": "string",
                  "enum": [
                     "vbc"
                  ],
                  "example": "vbc"
               },
               "extension": {
                  "type": "string",
                  "example": "447700900000"
               }
            },
            "required": [
               "type",
               "extension"
            ]
         },
         "conversation_numbers_whatsappvoice": {
            "description": "Whatsapp Voice Channel",
            "type": "object",
            "properties": {
               "type": {
                  "type": "string",
                  "enum": [
                     "whatsapp-voice"
                  ]
               },
               "number": {
                  "type": "string"
               }
            }
         },
         "conversation_error_not_found": {
            "type": "object",
            "description": "Conversation not found",
            "properties": {
               "title": {
                  "type": "string",
                  "example": "Not found."
               },
               "type": {
                  "type": "string",
                  "example": "https://developer.nexmo.com/api/conversation#conversation:error:not-found"
               },
               "code": {
                  "type": "string",
                  "example": "conversation:error:not-found"
               },
               "detail": {
                  "type": "string",
                  "example": "Conversation does not exist, or you do not have access."
               },
               "instance": {
                  "type": "string",
                  "example": "00a5916655d650e920ccf0daf40ef4ee"
               }
            }
         },
         "event_error_not_found": {
            "type": "object",
            "description": "Event not found",
            "properties": {
               "title": {
                  "type": "string",
                  "example": "Not found."
               },
               "type": {
                  "type": "string",
                  "example": "https://developer.nexmo.com/api/conversation#event:error:not-found"
               },
               "code": {
                  "type": "string",
                  "example": "event:error:not-found"
               },
               "detail": {
                  "type": "string",
                  "example": "Event does not exist, or you do not have access."
               },
               "instance": {
                  "type": "string",
                  "example": "fd26b002-91de-4ec5-8e95-2c04a261118a"
               }
            }
         },
         "conversation_members": {
            "type": "object",
            "properties": {
               "id": {
                  "$ref": "#/components/schemas/member_id"
               },
               "state": {
                  "$ref": "#/components/schemas/member_state"
               }
            }
         },
         "member_lite": {
            "type": "object",
            "properties": {
               "id": {
                  "$ref": "#/components/schemas/member_id"
               },
               "state": {
                  "$ref": "#/components/schemas/member_state"
               },
               "_embedded": {
                  "type": "object",
                  "properties": {
                     "user": {
                        "$ref": "#/components/schemas/user_lite"
                     }
                  }
               },
               "_links": {
                  "type": "object",
                  "properties": {
                     "href": {
                        "$ref": "#/components/schemas/member_href"
                     }
                  }
               }
            }
         },
         "member": {
            "type": "object",
            "properties": {
               "id": {
                  "$ref": "#/components/schemas/member_id"
               },
               "conversation_id": {
                  "$ref": "#/components/schemas/conversation_id"
               },
               "_embedded": {
                  "type": "object",
                  "properties": {
                     "user": {
                        "$ref": "#/components/schemas/user_lite"
                     }
                  }
               },
               "state": {
                  "$ref": "#/components/schemas/member_state"
               },
               "timestamp": {
                  "$ref": "#/components/schemas/member_timestamp"
               },
               "initiator": {
                  "$ref": "#/components/schemas/member_initiator"
               },
               "channel": {
                  "$ref": "#/components/schemas/channel"
               },
               "media": {
                  "$ref": "#/components/schemas/media"
               },
               "knocking_id": {
                  "type": "string",
                  "description": "The ID of the original knocker request (if applicable)."
               },
               "invited_by": {
                  "type": "string",
                  "description": "The member ID of the member that invited this member to the conversation (if applicable).",
                  "example": "MEM-63f61863-4a51-4f6b-86e1-46edebio0378"
               },
               "_links": {
                  "type": "object",
                  "properties": {
                     "href": {
                        "$ref": "#/components/schemas/member_href"
                     }
                  }
               }
            }
         },
         "member_id": {
            "type": "string",
            "example": "MEM-63f61863-4a51-4f6b-86e1-46edebio0391",
            "description": "Member ID"
         },
         "member_state_request": {
            "type": "string",
            "description": "Invite or join a member to a conversation",
            "example": "invited",
            "enum": [
               "invited",
               "joined"
            ]
         },
         "member_state": {
            "type": "string",
            "description": "The state that the member is in. Possible values are `INVITED`, `JOINED`, `LEFT`, or `UNKNOWN`",
            "example": "JOINED",
            "enum": [
               "INVITED",
               "JOINED",
               "LEFT",
               "UNKNOWN"
            ]
         },
         "member_href": {
            "type": "string",
            "format": "url",
            "example": "https://api.nexmo.com/v1/conversations/CON-63f61863-4a51-4f6b-86e1-46edebio0391/members/MEM-63f61863-4a51-4f6b-86e1-46edebio0391",
            "description": "A link towards a member included in Conversation API"
         },
         "member_timestamp": {
            "type": "object",
            "properties": {
               "invited": {
                  "description": "The time that the member was invited to a conversation",
                  "$ref": "#/components/schemas/timestamp"
               },
               "joined": {
                  "description": "The time that the member joined the conversation",
                  "$ref": "#/components/schemas/timestamp"
               },
               "left": {
                  "description": "The time that the member left the conversation",
                  "$ref": "#/components/schemas/timestamp"
               }
            }
         },
         "member_id_inviting": {
            "type": "string",
            "example": "MEM-63f61863-4a51-4f6b-86e1-46edebio0391",
            "description": "Member ID of the member that sends the invitation"
         },
         "member_from": {
            "type": "string"
         },
         "member_initiator": {
            "oneOf": [
               {
                  "type": "object",
                  "title": "Invited by User",
                  "properties": {
                     "joined": {
                        "type": "object",
                        "properties": {
                           "is_system": {
                              "type": "boolean",
                              "description": "`false` if the user was invited by a user."
                           },
                           "user_id": {
                              "$ref": "#/components/schemas/user_id"
                           },
                           "member_id": {
                              "$ref": "#/components/schemas/member_id"
                           }
                        }
                     }
                  }
               },
               {
                  "type": "object",
                  "title": "Invited by Admin JWT",
                  "properties": {
                     "invited": {
                        "type": "object",
                        "properties": {
                           "is_system": {
                              "type": "boolean",
                              "description": "`true` if the user was invited by an admin JWT."
                           }
                        }
                     }
                  }
               }
            ]
         },
         "member_error_not_found": {
            "type": "object",
            "description": "Member not found",
            "properties": {
               "title": {
                  "type": "string",
                  "example": "Not found."
               },
               "type": {
                  "type": "string",
                  "example": "https://developer.nexmo.com/api/conversation#conversation:error:member-not-found"
               },
               "code": {
                  "type": "string",
                  "example": "conversation:error:member-not-found"
               },
               "detail": {
                  "type": "string",
                  "example": "Member does not exist, or you do not have access."
               },
               "instance": {
                  "type": "string",
                  "example": "00a5916655d650e920ccf0daf40ef4ee"
               }
            }
         },
         "member_error_already_joined": {
            "type": "object",
            "description": "Member already joined",
            "properties": {
               "title": {
                  "type": "string",
                  "example": "Bad request."
               },
               "type": {
                  "type": "string",
                  "example": "https://developer.nexmo.com/api/conversation#conversation:error:member-already-joined"
               },
               "code": {
                  "type": "string",
                  "example": "conversation:error:member-already-joined"
               },
               "detail": {
                  "type": "string",
                  "example": "The request failed due to the user already having a member joined in 'app' type. Please provide a valid user and try again."
               },
               "instance": {
                  "type": "string",
                  "example": "00a5916655d650e920ccf0daf40ef4ee"
               }
            }
         },
         "member_error_invalid_state": {
            "type": "object",
            "description": "Invalid member state",
            "properties": {
               "title": {
                  "type": "string",
                  "example": "Conflict."
               },
               "type": {
                  "type": "string",
                  "example": "https://developer.nexmo.com/api/conversation#conversation:error:invalid-member-state"
               },
               "code": {
                  "type": "string",
                  "example": "conversation:error:invalid-member-state"
               },
               "detail": {
                  "type": "string",
                  "example": "The conversation membership has already ended."
               },
               "instance": {
                  "type": "string",
                  "example": "00a5916655d650e920ccf0daf40ef4ee"
               }
            }
         },
         "member_error_validation_state_invited": {
            "type": "object",
            "description": "Validation fail",
            "properties": {
               "title": {
                  "type": "string",
                  "example": "Bad request."
               },
               "type": {
                  "type": "string",
                  "example": "https://developer.nexmo.com/api/conversation#http:error:validation-fail"
               },
               "code": {
                  "type": "string",
                  "example": "http:error:validation-fail"
               },
               "detail": {
                  "type": "string",
                  "example": "Input validation failure."
               },
               "instance": {
                  "type": "string",
                  "example": "00a5916655d650e920ccf0daf40ef4ee"
               },
               "invalid_parameters": {
                  "type": "array",
                  "description": "List of invalid parameters",
                  "items": {
                     "type": "object",
                     "properties": {
                        "name": {
                           "type": "string",
                           "example": "state"
                        },
                        "reason": {
                           "type": "string",
                           "example": "\"state\" must be one of [invited, joined]"
                        }
                     }
                  }
               }
            }
         },
         "member_error_validation_state": {
            "type": "object",
            "description": "Validation fail",
            "properties": {
               "title": {
                  "type": "string",
                  "example": "Bad request."
               },
               "type": {
                  "type": "string",
                  "example": "https://developer.nexmo.com/api/conversation#http:error:validation-fail"
               },
               "code": {
                  "type": "string",
                  "example": "http:error:validation-fail"
               },
               "detail": {
                  "type": "string",
                  "example": "Input validation failure."
               },
               "instance": {
                  "type": "string",
                  "example": "00a5916655d650e920ccf0daf40ef4ee"
               },
               "invalid_parameters": {
                  "type": "array",
                  "description": "List of invalid parameters",
                  "items": {
                     "type": "object",
                     "properties": {
                        "name": {
                           "type": "string",
                           "example": "state"
                        },
                        "reason": {
                           "type": "string",
                           "example": "\"state\" must be one of [invited, joined, left]"
                        }
                     }
                  }
               }
            }
         },
         "member_channel_from": {
            "type": "object",
            "description": "Which channel types this member accepts messages from (if not set, all are accepted)",
            "properties": {
               "type": {
                  "description": "Comma sperated list, can include channel types `app`, `phone`, `sms`, `mms`, `whatsapp` , `viber`, or `messenger`",
                  "type": "string"
               }
            }
         },
         "channel": {
            "description": "A user who joins a conversation as a member can have one channel per membership. For more details see [channel concept docs](/conversation/concepts/channel)",
            "type": "object",
            "oneOf": [
               {
                  "type": "object",
                  "title": "App",
                  "description": "Member is using app channel type",
                  "properties": {
                     "type": {
                        "type": "string",
                        "description": "Channel type",
                        "enum": [
                           "app"
                        ]
                     },
                     "from": {
                        "$ref": "#/components/schemas/member_channel_from"
                     },
                     "to": {
                        "type": "object",
                        "description": "Settings which control who this member can send messages to.",
                        "properties": {
                           "type": {
                              "type": "string",
                              "enum": [
                                 "app"
                              ]
                           },
                           "user": {
                              "description": "The user ID of the member that this member can send messages to.",
                              "type": "string"
                           }
                        }
                     }
                  },
                  "required": [
                     "type"
                  ]
               },
               {
                  "type": "object",
                  "title": "Phone",
                  "description": "Member is using phone channel type",
                  "properties": {
                     "type": {
                        "type": "string",
                        "description": "Channel type",
                        "enum": [
                           "phone"
                        ]
                     },
                     "from": {
                        "$ref": "#/components/schemas/member_channel_from"
                     },
                     "to": {
                        "type": "object",
                        "description": "Settings which control who this member can send messages to.",
                        "properties": {
                           "number": {
                              "type": "string",
                              "description": "The phone number of the member that this member can send messages to."
                           },
                           "type": {
                              "type": "string",
                              "enum": [
                                 "phone"
                              ]
                           }
                        }
                     }
                  },
                  "required": [
                     "type"
                  ]
               },
               {
                  "type": "object",
                  "title": "SMS",
                  "properties": {
                     "type": {
                        "type": "string",
                        "description": "Channel type",
                        "enum": [
                           "sms"
                        ]
                     },
                     "from": {
                        "$ref": "#/components/schemas/member_channel_from"
                     },
                     "to": {
                        "type": "object",
                        "properties": {
                           "number": {
                              "type": "string"
                           },
                           "type": {
                              "type": "string",
                              "enum": [
                                 "sms"
                              ]
                           }
                        }
                     }
                  }
               },
               {
                  "type": "object",
                  "title": "MMS",
                  "properties": {
                     "type": {
                        "type": "string",
                        "description": "Channel type",
                        "enum": [
                           "mms"
                        ]
                     },
                     "from": {
                        "$ref": "#/components/schemas/member_channel_from"
                     },
                     "to": {
                        "type": "object",
                        "properties": {
                           "number": {
                              "type": "string"
                           }
                        }
                     }
                  }
               },
               {
                  "type": "object",
                  "title": "WhatsApp",
                  "properties": {
                     "type": {
                        "type": "string",
                        "description": "Channel type",
                        "enum": [
                           "whatsapp"
                        ]
                     },
                     "from": {
                        "$ref": "#/components/schemas/member_channel_from"
                     },
                     "to": {
                        "type": "object",
                        "properties": {
                           "number": {
                              "type": "string"
                           }
                        }
                     }
                  }
               },
               {
                  "type": "object",
                  "title": "Viber",
                  "properties": {
                     "type": {
                        "type": "string",
                        "description": "Channel type",
                        "enum": [
                           "viber"
                        ]
                     },
                     "from": {
                        "$ref": "#/components/schemas/member_channel_from"
                     },
                     "to": {
                        "type": "object",
                        "properties": {
                           "id": {
                              "type": "string"
                           }
                        }
                     }
                  }
               },
               {
                  "type": "object",
                  "title": "Messenger",
                  "properties": {
                     "type": {
                        "type": "string",
                        "description": "Channel type",
                        "enum": [
                           "messenger"
                        ]
                     },
                     "from": {
                        "$ref": "#/components/schemas/member_channel_from"
                     },
                     "to": {
                        "type": "object",
                        "properties": {
                           "id": {
                              "type": "string"
                           }
                        }
                     }
                  }
               }
            ]
         },
         "action": {
            "type": "string",
            "example": "start",
            "description": "Recording Action",
            "enum": [
               "start",
               "stop"
            ]
         },
         "event_url": {
            "type": "array",
            "items": {
               "type": "string",
               "format": "url"
            },
            "example": [
               "https://example.com/event"
            ],
            "x-nexmo-developer-collection-description-shown": true,
            "description": "The webhook endpoint where recording progress events are sent to."
         },
         "event_method": {
            "type": "string",
            "description": "The HTTP method used to send event information to event_url.",
            "example": "POST",
            "default": "POST"
         },
         "split": {
            "type": "string",
            "description": "Record the sent and received audio in separate channels of a stereo recording",
            "example": "conversation",
            "default": "conversation"
         },
         "format": {
            "type": "string",
            "description": "Record the Conversation in a specific format.",
            "example": "mp3",
            "default": "mp3",
            "enum": [
               "mp3",
               "wav",
               "vorbis"
            ]
         },
         "retention_ttl": {
            "type": "integer",
            "description": "The total number of days the recording will be stored for.",
            "default": 31,
            "minimum": 1,
            "maximum": 400
         },
         "timeout": {
            "type": "integer",
            "description": "The maximum duration of the recording in seconds.",
            "default": 7200,
            "maximum": 7200
         },
         "transcription": {
            "type": "object",
            "description": "Options to transcribe the recording into text.",
            "properties": {
               "language": {
                  "type": "string",
                  "default": "en-US",
                  "description": "The language to transcribe the recording into. See supported languages at https://developer.vonage.com/en/voice/voice-api/concepts/asr#language\n"
               },
               "sentiment_analysis": {
                  "type": "boolean",
                  "description": "Whether to include sentiment analysis in the transcription."
               },
               "event_url": {
                  "type": "array",
                  "items": {
                     "type": "string",
                     "format": "uri"
                  },
                  "description": "The URL(s) where the transcription callback will be sent."
               },
               "event_method": {
                  "type": "string",
                  "enum": [
                     "GET",
                     "POST"
                  ],
                  "description": "The HTTP method used when calling the transcription event_url."
               }
            }
         },
         "leg_state": {
            "type": "string",
            "example": "terminated",
            "description": "Leg Status",
            "enum": [
               "terminated"
            ]
         },
         "user_id_or_user_name": {
            "type": "string",
            "description": "user name or user id of the inviter",
            "example": "someone_else_user_name"
         },
         "name": {
            "type": "string",
            "example": "my_unique_name",
            "description": "Unique name"
         },
         "name_conversation": {
            "type": "string",
            "example": "customer_chat",
            "description": "Unique name for a conversation"
         },
         "href": {
            "type": "string",
            "format": "url",
            "example": "https://api.nexmo.com/v1/conversations/CON-63f61863-4a51-4f6b-86e1-46edebio0391",
            "description": "A link towards a resources included in Conversation API"
         },
         "href_conversation": {
            "type": "string",
            "format": "url",
            "example": "https://api.nexmo.com/v1/conversations/CON-63f61863-4a51-4f6b-86e1-46edebio0391",
            "description": "A link towards a conversation included in Conversation API"
         },
         "href_conversations_list": {
            "type": "string",
            "format": "url",
            "example": "https://api.nexmo.com/v1/conversations?page_size=2&record_index=10&",
            "description": "A link towards a conversations list included in Conversation API"
         },
         "href_user": {
            "type": "string",
            "format": "url",
            "example": "https://api.nexmo.com/v1/users/USR-63f61863-4a51-4f6b-86e1-46edebio0391",
            "description": "A link towards a user included in Conversation API"
         },
         "href_event": {
            "type": "string",
            "format": "url",
            "example": "https://api.nexmo.com/v1/conversations/CON-63f61863-4a51-4f6b-86e1-46edebio0391/events/1",
            "description": "A link towards a conversation event included in Conversation API"
         },
         "href_rtc": {
            "type": "string",
            "format": "url",
            "example": "https://api.nexmo.com/v1/conversations/CON-63f61863-4a51-4f6b-86e1-46edebio0391/rtc/7777777777777",
[...]
